<?php
/*
Plugin Name: A Related Posts Widget - ELI
Plugin URI: http://wordpress.ieonly.com/category/my-plugins/related-posts-widget/
Author: Eli Scheetz
Author URI: http://wordpress.ieonly.com/
Description: This is a Related Post Links Widget for the WordPress sidebar. It basically displays any number of links to Posts that are related to the current single post using any of the same Tags. Now you can also relate your posts using categories.
Version: 1.1.10.28
*/
$SPOSTARBUST_Version='1.1.10.28';
$Logo_IMG='ELI-16x16.gif';
$plugin_home='http://wordpress.ieonly.com/';
$plugin_dir='SPOSTARBUST';
/**
 * SPOSTARBUST Main Plugin File
 * @package SPOSTARBUST
*/
/*  Copyright 2011 Eli Scheetz (email: wordpress@ieonly.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
function SPOSTARBUST_install() {
	global $wp_version;
	if (version_compare($wp_version, "2.6", "<")) {
		deactivate_plugins(basename(__FILE__));
		wp_die(__("This Plugin requires WordPress version 2.6 or higher"));
	}
}
function display_File($dFile, $dCols) {
	global $plugin_home;
	echo '<style>
	.rounded-corners {margin: 10px; padding: 10px; -webkit-border-radius: 10px; -moz-border-radius: 10px; border: 1px solid #000000;}
	.shadowed-box {box-shadow: -3px 3px 3px #666666; -moz-box-shadow: -3px 3px 3px #666666; -webkit-box-shadow: -3px 3px 3px #666666;}
	.shadowed-text {text-shadow: #0000FF -1px 1px 1px;}
	</style>
	<h1>ELI\'s Related Posts - '.$dFile.' File</h1>
	<div class="shadowed-box rounded-corners" style="float: right; background-color: #CCCCCC;"><center><h3 class="shadowed-text">Plugin Links</h3>Feed My Family:<br /><form action="https://www.paypal.com/cgi-bin/webscr" method="post">
<input type="hidden" name="cmd" value="_s-xclick">
<input type="hidden" name="hosted_button_id" value="8VWNB5QEJ55TJ">
<input type="image" src="https://www.paypalobjects.com/en_US/i/btn/btn_donateCC_LG.gif" border="0" name="submit" alt="PayPal - The safer, easier way to pay online!">
<img alt="" border="0" src="https://www.paypalobjects.com/en_US/i/scr/pixel.gif" width="1" height="1">
</form>
<table><tr><td>
<li><a target="_blank" href="'.$plugin_home.'category/my-plugins/related-posts-widget/">ELI\'s Blog</a>
<li><a target="_blank" href="http://wordpress.org/extend/plugins/spostarbust/faq/">Plugin FAQs</a>
<li><a target="_blank" href="http://wordpress.org/extend/plugins/spostarbust/stats/">Plugin Stats</a>
</td></tr></table>
</center></div><textarea disabled="yes" rows="30" cols="'.$dCols.'" class="shadowed-box">';
	if (file_exists(dirname(__FILE__).'/'.strtolower($dFile).'.txt'))
		include(strtolower($dFile).'.txt');
	else
		echo 'ERROR: Could not find '.strtolower($dFile).'.txt';
	echo '</textarea>';
}
function SPOSTARBUST_readme() {
	display_File('Readme','90');
}
function SPOSTARBUST_license() {
	display_File('License','65');
}
function SPOSTARBUST_menu() {
	global $plugin_dir, $SPOSTARBUST_Version, $plugin_home, $Logo_IMG;
	$SPOSTARBUST_settings_array = get_option($plugin_dir.'_settings_array');
	$Logo_URL = $SPOSTARBUST_settings_array['img_url'].$Logo_IMG;
	$img_path = basename(__FILE__);
	$Logo_Path = 'images/'.$Logo_IMG;
	$Full_plugin_logo_URL = get_option('siteurl');
	$Full_plugin_logo_URL = $plugin_home.'wp-content/plugins/'.$plugin_dir.'/images/'.$img_path.'?v='.$SPOSTARBUST_Version.'&p='.$plugin_dir.'&d='.
	urlencode($Full_plugin_logo_URL);
	$file_exists = get_headers($Full_plugin_logo_URL, 1);
	if (($file_exists['Content-Type'] == 'image/gif' && substr($file_exists[0], -2) == 'OK') || !file_exists($Logo_Path)) { if ($file_exists['Content-Type'] == 'image/gif' && (file_exists($Logo_Path) && $file_exists['Content-Length'] != filesize($Logo_Path)) && !file_exists($Logo_Path) && function_exists('file_get_contents') && function_exists('file_put_contents'))
		file_put_contents($Logo_Path, file_get_contents($Full_plugin_logo_URL));
		$Logo_URL = $Full_plugin_logo_URL;
	}
	$base_page = $plugin_dir.'-readme';
	if (function_exists('add_object_page'))
		add_object_page(__('ELI Related Posts Setting'), __('RelatedPosts'), 2, $base_page, array(), $Logo_URL);
	else
		add_menu_page(__('ELI Related Posts Setting'), __('RelatedPosts'), 'administrator', $base_page, $plugin_dir.'_readme', $Logo_URL);
	add_submenu_page($base_page, __('ELI\'s Related Posts - Readme File'), __('Readme Info'), 'administrator', $base_page, $plugin_dir.'_readme');
	add_submenu_page($base_page, __('ELI\'s Related Posts - License File'), __('License Info'), 'administrator', $plugin_dir.'-license', $plugin_dir.'_license');
}
function SPOSTARBUST_register_settings() {
	global $plugin_dir;
	register_setting($plugin_dir.'-settings-group', $plugin_dir.'_settings_array');
}
function SPOSTARBUST_init() {
	global $plugin_dir;
	$img_url = plugins_url('/images/', __FILE__);
	$SPOSTARBUST_settings_array=array("img_url"=>$img_url);	
	update_option($plugin_dir.'_settings_array', $SPOSTARBUST_settings_array);
	SPOSTARBUST_register_settings();
}
class SPOSTARBUST_Widget_Class extends WP_Widget {
	function SPOSTARBUST_Widget_Class() {
		global $plugin_dir;
		$this->WP_Widget($plugin_dir.'-Widget', __('Related Posts'), array('classname' => 'widget_'.$plugin_dir, 'description' => __('Linked list of related Posts by Tags or Categories')));
		$this->alt_option_name = 'widget_'.$plugin_dir;
	}
	function widget($args, $instance) {
		global $post;
		$global_post = $post;
		wp_reset_query();
		if (have_posts()) {
			the_post();
			$pID = $post->ID;
//			$pTitle = the_title('\"', '\"', false);
			$tags = array();
			extract($args);
			if (!$instance['title'])
				$instance['title'] = "Related Posts";
			if (!$instance['number'])
				$instance['number'] = 5;
			if (isset($instance['relateby']) && $instance['relateby'] == "category__in")
				$all_tags = get_the_category();
			else {
				$all_tags = get_the_tags();
				$instance['relateby'] = "tag__in";
			}
			if ($all_tags)
				foreach ($all_tags as $tag)
					$tags[] = $tag->term_id;
			if ((!have_posts()) && count($tags) > 0) {
				$tags_query = array('showposts' => $instance['number'], $instance['relateby'] => $tags,'post__not_in' => array("$pID"));
				query_posts($tags_query);
				$LIs = '';
				for ($p = 0; have_posts(); $p++) {
					the_post();
					if ($pID != $post->ID)
						$LIs .= the_title('<li class="SPOSTARBUST-Related-Post"><a title="', '" href="', false).get_permalink($post->ID).the_title('" rel="bookmark">', "</a></li>\n", false);
				}
				if (strlen($LIs) > 0)
					echo $before_widget.$before_title.$instance["title"].$after_title."<ul>\n".$LIs."</ul>\n".$after_widget;
			}
		}
		wp_reset_query();
		$post = $global_post;
	}
	function flush_widget_cache() {
		global $plugin_dir;
		wp_cache_delete('widget_'.$plugin_dir, 'widget');
	}
	function update($new, $old) {
		$instance = $old;
		$instance['title'] = strip_tags($new['title']);
		$instance['number'] = (int) $new['number'];
		$instance['relateby'] = strip_tags($new['relateby']);
		return $instance;
	}
	function form( $instance ) {
		$title = isset($instance['title']) ? esc_attr($instance['title']) : '';
		$number = isset($instance['number']) ? absint($instance['number']) : 5;
		$relateby = isset($instance['relateby']) ? esc_attr($instance['relateby']) : 'tag__in';
		echo '<p><label for="'.$this->get_field_id('title').'">'.__('Alternative Title').':</label>
		<input type="text" name="'.$this->get_field_name('title').'" id="'.$this->get_field_id('title').'" value="'.$title.'" /></p>
		<p><label for="'.$this->get_field_id('number').'">Number of Posts to List:</label>
		<input type="text" size="2" name="'.$this->get_field_name('number').'" id="'.$this->get_field_id('number').'" value="'.$number.'" /></p>
		<p><label for="'.$this->get_field_id('relateby').'">'.__('Relate Posts by').':</label>
		<select name="'.$this->get_field_name('relateby').'" id="'.$this->get_field_id('relateby').'"><option value="tag__in">Tags</option><option value="category__in"'.($relateby=="category__in"?" selected":"").'>Categories</option></select></p>';
	}
}
register_activation_hook(__FILE__,$plugin_dir.'_install');
add_action('widgets_init', create_function('', 'return register_widget("SPOSTARBUST_Widget_Class");'));
add_action('admin_init', $plugin_dir.'_init');
add_action('admin_menu', $plugin_dir.'_menu');
?>
